#define INITGUID

#include "..\..\shared\CClassFactoryBase.h"
#include "..\..\shared\Interfaces.h"			// wg. Interface GUIDs
#include "..\SimpleBox\ISimpleBox.h"			// wg. Interface GUIDs
#include "..\WinGUI\IWinGUI.h"					// wg. Interface GUIDs
#include "CFEMPlotter.h"

const int g_Version	= 1;



#include "..\..\shared\CInstanceFactory.h"

CInstanceFactory *_g_Factory=0;


CClassFactoryData	g_ClassFactoryData[]	= {
	{&CFEMPlotter::_GetGUID(),"MIT.FEMPlotter",&g_Version,CFEMPlotter::CreateComponent},
	END_FACTORY
	};


IEditorApplication *g_App;
extern "C" __declspec(dllexport) bool InitDLL(IUnknown *p)		// mu auch in DEF Datei stehen
{
	IEditorApplication *m;
	
	p->QueryInterface(IID_IEditorApplication,(LPVOID *)&m);

	if(!m)
		return(false);

	if(m->GetVersion()!=0)
		return(false);

	g_App=m;

	// Plugins
	_g_Factory=g_App->GetFactory();

	return(true);
}
