//-------------------------------------------------------------------+
// FemCoord.h                                                        |
//-------------------------------------------------------------------+
// Definiton von (x,y)-Koordinaten                                   |
//-------------------------------------------------------------------+
// Author: Tobias Lang                                               |
//-------------------------------------------------------------------+
// (c) Copyright 2001 by Tobias Lang                                 |
//-------------------------------------------------------------------+ t.l. 22.02.2001
#ifndef _DVA_FEM_COORD_H__
#define _DVA_FEM_COORD_H__


//! Struktur zur Darstellung von (x,y)-Koordinaten-Paare
//
struct tagCoord
{
    float x;    //!< x-Komponente
    float y;    //!< y-Komponente
};

//! Hilfs-Struktur zur temporren Darstellung von (x,y)-Koordinaten-Paare bei FEM3
//
struct tagFEM3Coord
{
    int   iNodeNr;  //!< Knotenpunktsnummer laut FEM-IN-Datei, 0 => muss interpoliert werden
    float x;        //!< x-Komponente
    float y;        //!< y-Komponente

    tagFEM3Coord():iNodeNr(0)
    {
    }
};

#endif//_DVA_FEM_COORD_H__