#ifndef _MESSAGE_HANDLER_H
#define _MESSAGE_HANDLER_H

#include <objbase.h>

#ifdef INITGUID
#include <initguid.h>
#endif

class IMessageHandler : public IUnknown
{
	public:
		virtual void	__stdcall	Create		( int len=25, int fin=0 )=0;
		virtual void    __stdcall	Add         ( char *, ... )=0;
		virtual void    __stdcall	Print       ( void )=0;
		virtual void    __stdcall	Save        ( char *name )=0;
		virtual void    __stdcall	AddDirectX  ( char *txt, HRESULT hr )=0;
		virtual void	__stdcall	FreeAllData	( void )=0;
};


// {CF1A241F-7D0D-4f15-A5CC-254A071AB45A}
DEFINE_GUID(IID_IMessageHandler, 0xcf1a241f, 0x7d0d, 0x4f15, 0xa5, 0xcc, 0x25, 0x4a, 0x7, 0x1a, 0xb4, 0x5a);

#endif