// Nicht vergesssen:
//
// keine strings in interfaces verwenden, wg. Freigabeproblematik mit DLLs

#ifndef _ISIMPLEBOX_H
#define _ISIMPLEBOX_H

/*#include "Datatypes.h"
#include "handle.h"		// CHandle
#include <objbase.h>
#include <string>
//#include <iostream>
using namespace std;

class CInstanceFactory;
class I2DMemoryDC;
class IMessageHandler;
class CWnd;
class CSerializeArchivePointer;
class IEditorDocument;

*/
class CPoint2I;
class CRect2I;

// ****************************************************************************************
// ****************************************************************************************
// ****************************************************************************************
// ****************************************************************************************



// eigentlich msste das nicht virtuell sein, so ist es eigentlich ineffizient, dafr
// aber wenigstens homogen ein gleiches System.

// Interface Name
class ISceneGraphRootObject : public IUnknown//: public virtual ISceneGraphObject
{
public:
	// Interface Methods
	virtual bool						Init			( IEditorDocument *pDoc )=0;
//	virtual void						SetToolMode		( int i )=0;					//
//	virtual int							GetToolMode		( void )=0;						//

	virtual void						RedrawAll		( void )=0;						// besser wre es partiell

	// Maus
	// MouseMove wird for Frame nur einmal aufgerufen
	virtual	void						OnMouseMove		( CPoint2I xy, ULONG dwOldFlags, ULONG dwNewFlags )=0;
	// MouseButton wird unter Umstnden in einem Frame mehrmals aufgerufen
	virtual	void						OnMouseButton	( CPoint2I xy, ULONG dwOldFlags, ULONG dwNewFlags )=0;
};

DEFINE_GUID(IID_ISceneGraphRootObject, 0x3a72b01f, 0x1337, 0x4caf, 0x9a, 0x75, 0xec, 0x7b, 0xa2, 0xf1, 0x17, 0x17);


// ****************************************************************************************
// ****************************************************************************************
// ****************************************************************************************
// ****************************************************************************************

class I2DDraw : public IUnknown 
{ 
public:
	// Interface Methods
	virtual void			Draw				( I2DMemoryDC *pMC, CPoint2I pos, int inMagnify )=0;
	virtual void			MoveObject			( CPoint2I rel, ULONG &AnchorPoint )=0;
	virtual void			ScaleObject			( CPoint2I rel )=0;
	virtual void			MarkedDraw			( I2DMemoryDC *pMC, int r, CPoint2I pos, int inMagnify )=0;	//wird zusttzlich zu Draw aufgerufen, wenn Objekt markiert ist
	virtual ULONG			IsAnchorPointAt		( int r, CPoint2I xy )=0;	// nur fr markierte Objekte, 0, wenn dort kein Punkt, sonst ist dort ein Angriffspunkt (Skalieren, ...)
	virtual bool			IsObjectAt			( CPoint2I xy )=0;
	virtual	CRect2I			GetRect				( void )=0;
	virtual	void			SetRect				( const CRect2I &r )=0;
	virtual I2DDraw *		GetTopObjectAt		( CPoint2I xy )=0;			// arbeitet auch rekursiv
	virtual I2DDraw *		GetTopAnchorPointAt ( int r, CPoint2I xy, ULONG &anchorid )=0;	// arbeitet rekursiv, id von 1 bis ...
	virtual	void			OnContextMenu		( IPopUpMenu *p, CPoint2I xy )=0;
	virtual	CPoint2I		GetWorldPosition	( void )=0;					// arbeitet rekursiv
};

// {9AA74F19-5A88-4b7f-ACED-8F8C27A62951}
DEFINE_GUID(IID_I2DDraw, 0x9aa74f19, 0x5a88, 0x4b7f, 0xac, 0xed, 0x8f, 0x8c, 0x27, 0xa6, 0x29, 0x51);

// ****************************************************************************************

// ****************************************************************************************
// ****************************************************************************************
// ****************************************************************************************
// ****************************************************************************************



class IConnector :public IUnknown 
{
public:
	// Interface Methods

	virtual	void				SetFrom				( ISceneGraphObject *p )=0;
	virtual	void				SetTo				( ISceneGraphObject *p )=0;
	virtual	ISceneGraphObject *	GetFrom				( void )=0;
	virtual	ISceneGraphObject *	GetTo				( void )=0;
};

// {622F1B6B-18A4-4272-AE9F-05C5AE2D03A2}
DEFINE_GUID(IID_IConnector, 0x622f1b6b, 0x18a4, 0x4272, 0xae, 0x9f, 0x5, 0xc5, 0xae, 0x2d, 0x3, 0xa2);

// ****************************************************************************************
// ****************************************************************************************
// ****************************************************************************************
// ****************************************************************************************
// ****************************************************************************************
// ****************************************************************************************





#endif // _INTERFACES_H
