// GuidTypDef.h: interface for the CGuidTypDef class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GUIDTYPDEF_H__DAD90DD7_84B2_4139_9B5B_D243E474497F__INCLUDED_)
#define AFX_GUIDTYPDEF_H__DAD90DD7_84B2_4139_9B5B_D243E474497F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// diese Klasse wird fr CSerializeArchive::Load bentigt


enum CGuidTypDefState
{
	GTDS_notset			=0,	// undefiniert
	GTDS_fastread		=1,	// Typ hat exakt gleichen Attributaufbau wie in Datei
	GTDS_recover		=2	// Typaufbau hat sich gendert, vor Attributlesen mu der Speicherblock
							// noch bearbeitet werden
};





class CGuidTypDef  
{
//private:
public:

	GUID					m_Guid;			// GUID des Objekttypes
	char *					m_attribdef;	// Abfolge der Attribute (siehe auch SerializeAchive.h) 
	enum CGuidTypDefState	m_state;		// Zustand (fastread/recover/noch nicht ermittelt)
	




public:
	// Konstruktor/Destruktor
					CGuidTypDef			();
					CGuidTypDef			( const CGuidTypDef &p );	// Copy-Konstruktor
	virtual			~CGuidTypDef		();

	// Attibutzugriff
	void			SetGuid				( const GUID &p );
	const GUID &	GetGuid				( void ) const; 

	void			SetAttribDef		( const char *p );		// errechnet auch m_ByteSize
	const char *	GetAttribDef		( void ) const;			// mu 0-terminiert sein

   CGuidTypDefState GetState			( void ) const ;
    void			SetState			( CGuidTypDefState state );

	// Vergleich
	CGuidTypDef		operator =			( const CGuidTypDef &a );		// Zuweisungsoperator, ist cosnt hier ok?
	bool			SameType			( const char *typestring );
};

#endif // !defined(AFX_GUIDTYPDEF_H__DAD90DD7_84B2_4139_9B5B_D243E474497F__INCLUDED_)
