// VectorN.h: Schnittstelle fr die Klasse CVectorN.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_VECTORN_H__81F2313C_5FE0_4150_8F39_3078D5551E18__INCLUDED_)
#define AFX_VECTORN_H__81F2313C_5FE0_4150_8F39_3078D5551E18__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


// von dieser sollen sich die anderen Vectorklassen ableiten

// Fehlerbehandlung mit exceptions oder assert

// berladen werden sollte unbedingt: Zuweisungsoperator, Copy-Konstruktor

/*!
    \brief Vaterklasse aller Vectorklassen
    \author Martin Mitting
    \version 0.1
    \date    31.01.2001
*/
template <class T>
class CVectorN  
{
public:

	//! Konstruktoren
								CVectorN		( void );

	//! Destruktor
	virtual ~					CVectorN		( void );

	//! fr lesenden elementweisen Zugriff 
	//! \param inZeile Zeile in der Matrix (von 0 an gezhlt)
    //! \return Element in der Matrix
	const T						P				( int inZeile ) const;		

	//! fr schreibenden elementweisen Zugriff 
	//! \param inZeile Zeile in der Matrix (von 0 an gezhlt)
	//! \param inValue Element in der Matrix
	void						P				( int inZeile, T &inValue );	

	//! Daten freigeben
	void						FreeData		( void );
};


// Konstruktor
template <class T>
CVectorN<T>::CVectorN( void )
{
}

// Destruktor
template <class T>
CVectorN<T>::~CVectorN( void )
{
}


#endif // !defined(AFX_VECTORN_H__81F2313C_5FE0_4150_8F39_3078D5551E18__INCLUDED_)
