#ifndef _DATATYPES_H
#define _DATATYPES_H

#define DEBUGSERIALIZE			// liefert viele Message-Ausgaben






typedef	unsigned char	UBYTE;
typedef	unsigned short	UWORD;
typedef	unsigned long	ULONG;

#include <assert.h>		// assert(..)


// normales DIK_ zwischen 0x00 und 0xff
//#define DIK2_MOUSELEFT		-1	// eigene Erweiterungen
//#define DIK2_MOUSERIGHT		-2  // eigene Erweiterungen
//#define DIK2_MOUSETHIRD		-3  // eigene Erweiterungen
//#define DIK2_ILLEGAL			-4  // eigene Erweiterungen
//#define DIK2_NONE				-5  // eigene Erweiterungen


// Initialisiert DirectX Strukturen
#define DX_CREATE_STRUCT(type,var) type var; ZeroMemory(&(var),sizeof(type)); var.dwSize = sizeof(type); 


typedef struct IDirectDraw7    *LPDIRECTDRAW7;

// ****************************************************************************



//#include "..\PlugInSource\GraphLib\DGraphLib.h"



// ****************************************************************************



#ifndef GUID_DEFINED						// aus winnt.h
#define GUID_DEFINED

typedef struct _GUID {          // size is 16
    unsigned long Data1;
    unsigned short   Data2;
    unsigned short   Data3;
    unsigned char  Data4[8];
} GUID;

#endif // !GUID_DEFINED



// die Routine gehrt hier nicht rein
inline GetStringFromGUID( const GUID &guid, char str[40] )
{
	UBYTE *p=(UBYTE *)&guid;
	int e=0;

	for(int i=0;i<16;i++)
	{
		UBYTE lo=*p&0xf;
		UBYTE hi=*p>>4;		p++;

		if(i<4)e=6-i*2;
		else if(i<6)e=19-2*i;
		else if(i<8)e=28-2*i;
		else e=i*2+3;

		if(hi<=9)str[e]='0'+hi; else str[e]='A'-10+hi;
		if(lo<=9)str[e+1]='0'+lo; else str[e+1]='A'-10+lo;
	}
	str[8]='-';
	str[13]='-';
	str[18]='-';
	str[16*2+3]=0;	// Endmarker
}


// ****************************************************************************

#endif // _DATATYPES_H